<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div>

  <div class="modal-header">
    <h4
      class="modal-title overflow-hidden text-overflow-ellipsis text-nowrap"
      id="modal-basic-title"
      [innerText]="messages.getAdminSubtypeTypologyPopupModalTitle(type, subtype)">
    </h4>
    <button
      type="button"
      class="btn-close"
      [title]="commonMessages.CLOSE"
      (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)">
    </button>
  </div>

  <div class="modal-body">

    <ul
      ngbNav
      #nav="ngbNav"
      class="ip-tabs">

      <li
        [ngbNavItem]="messages.GENERAL_TAB_TITLE"
        [destroyOnHide]="false">
        <a ngbNavLink>
          <span [innerText]="messages.GENERAL_TAB_TITLE"></span>
          <fa-icon
            *ngIf="!isGeneralTabValid"
            [icon]="commonIcons.INVALID_FORM_ICON"
            class="ip-tab-error-icon">
          </fa-icon>
        </a>
        <ng-template ngbNavContent>
          <app-subtype-general
            (valid)="isGeneralTabValid = $event"
            [type]="type"
            [tenantId]="tenantId"
            [userPreferences]="userPreferences"
            [subtype]="subtype">
          </app-subtype-general>
        </ng-template>
      </li>

      <li
        [ngbNavItem]="messages.PERMISSION_TAB_TITLE"
        [destroyOnHide]="false">
        <a ngbNavLink [innerText]="messages.PERMISSION_TAB_TITLE"></a>
        <ng-template ngbNavContent>
          <app-subtype-permissions
            [tenantId]="tenantId"
            [(isCreationPermittedPublic)]="isCreationPermittedPublic"
            [creationPermittedDesks]="creationPermittedDesks">
          </app-subtype-permissions>
        </ng-template>
      </li>

      <!-- Not working. Hidden then. -->
      <!--      <li-->
      <!--        [ngbNavItem]="messages.VISIBILITY_TAB_TITLE"-->
      <!--        [destroyOnHide]="false">-->
      <!--        <a ngbNavLink [innerText]="messages.VISIBILITY_TAB_TITLE"></a>-->
      <!--        <ng-template ngbNavContent>-->
      <!--          <app-subtype-visibility-->
      <!--            [filterableByDesks]="filterableByDesks"-->
      <!--            [(isFilterablePublic)]="isFilterablePublic"-->
      <!--            [tenantId]="tenantId">-->
      <!--          </app-subtype-visibility>-->
      <!--        </ng-template>-->
      <!--      </li>-->

      <li
        [ngbNavItem]="messages.WORKFLOWS_TAB_TITLE"
        [destroyOnHide]="true">
        <a ngbNavLink>
          <span [innerText]="messages.WORKFLOWS_TAB_TITLE"></span>
          <fa-icon
            *ngIf="!isWorkflowTabValid"
            [icon]="commonIcons.INVALID_FORM_ICON"
            class="ip-tab-error-icon">
          </fa-icon>
        </a>
        <ng-template ngbNavContent>
          <app-subtype-workflow
            (valid)="isWorkflowTabValid = $event"
            [tenantId]="tenantId"
            [type]="type"
            [subtype]="subtype">
          </app-subtype-workflow>
        </ng-template>
      </li>

      <li
        [ngbNavItem]="messages.METADATA_TAB_TITLE"
        [destroyOnHide]="false">
        <a ngbNavLink [innerText]="messages.METADATA_TAB_TITLE"></a>
        <ng-template ngbNavContent>
          <app-subtype-metadata
            [tenantId]="tenantId"
            [subtype]="subtype">
          </app-subtype-metadata>
        </ng-template>
      </li>

      <li
        [ngbNavItem]="messages.LAYER_TAB_TITLE"
        [destroyOnHide]="false">
        <a ngbNavLink [innerText]="messages.LAYER_TAB_TITLE"></a>
        <ng-template ngbNavContent>
          <app-subtype-layers
            [tenantId]="tenantId"
            [subtype]="subtype">
          </app-subtype-layers>
        </ng-template>
      </li>
    </ul>

    <div class="p-4" [ngbNavOutlet]="nav"></div>
  </div>

  <div class="modal-footer">
    <button
      ls-button-cancel
      (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)">
    </button>
    <button
      ls-button-save
      (click)="onSaveButtonClicked()"
      [disabled]="!validForms()"
      [processing]="isProcessing">
    </button>
  </div>

</div>
